#pragma once

#include <vector>

class Point3D{
public:
    Point3D(const double x, const double y, const double z);
    Point3D(const std::vector<double> r);
    void translate(const double dx, const double dy, const double dz);
    void translate(const std::vector<double> dr);
    /** Rotates this point about x, y, and z.
     * 
     *  The rotation is performed as if this point was first rotated by alpha around the x-axis, 
     *  then rotated by beta around the y-axis, and finally rotated by gamma around the z-axis.
     * 
     *  @param alpha rotation around x-axis
     *  @param beta rotation arounx y-axis
     *  @param gamma rotation around z-axis
     * 
     */
    void rotate(const double alpha, const double beta, const double gamma);
    const std::vector<double> coordinates();
private:
    double _x, _y, _z;
};
