module points

real, allocatable, dimension(:) :: x
real, allocatable, dimension(:) :: y
real, allocatable, dimension(:) :: z

contains
    subroutine init(N)
        integer, intent(in) :: N
        
        allocate(x(N))
        allocate(y(N))
        allocate(z(N))
        
    end subroutine init
    
    subroutine translate(idx, dx, dy, dz)
        integer, intent(in) :: idx
        real, intent(in) :: dx
        real, intent(in) :: dy
        real, intent(in) :: dz
        x(idx) = x(idx) + dx
        y(idx) = y(idx) + dy
        z(idx) = z(idx) + dz
    end subroutine translate
    
    subroutine coordinates(idx, tx, ty, tz)
        integer, intent(inout) :: idx
        real, intent(out) :: tx
        real, intent(out) :: ty
        real, intent(out) :: tz
        tx = x(idx)
        ty = y(idx)
        tz = z(idx)
    end subroutine coordinates
    
    subroutine set(idx, tx, ty, tz)
        integer, intent(in) :: idx
        real, intent(in) :: tx
        real, intent(in) :: ty
        real, intent(in) :: tz
        x(idx) = tx
        y(idx) = ty
        z(idx) = tz
    end subroutine set
    
    subroutine finalize
        deallocate (x, y, z)
    end subroutine finalize
    
end module points
        
